/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KSIGNAL_H_INCLUDED_
#define _KSIGNAL_H_INCLUDED_

namespace Sith
{
	// KSIGNAL enumeration
	// - Defines standard signals that operate upon Tasks
	typedef enum KSIGNAL
	{
		KS_NULL,	// Null signal, like the goggles it does nothing

		KS_TERM,	// Polite termination
		KS_KILL,	// Kernel level termination

		KS_PAUSE,	// Polite pause
		KS_START,	// Polite start

		KS_QUIT,	// Send quit message to kernel
	};
};

#endif // _KSIGNAL_H_INCLUDED_