/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _VFILE_H_INCLUDED_
#define _VFILE_H_INCLUDED_

namespace Sith
{
	namespace VFS
	{
		class VFile
		{
		private:
			std::string ContainerFileName;
			unsigned int ContainerFileOffset;
			unsigned int FileLength;

		public:
			std::string Name;

			FILE* Open(bool isAscii);
			const char* OpenBuffer();

			VFile(std::string theName, std::string theContainerFile, unsigned int theOffset, unsigned int theLength);
		};
	};
};

#endif // _VFILE_H_INCLUDED_